package urti;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;

import javax.swing.JPanel;

public class JRail extends JPanel implements Runnable {

	private boolean running = false;
	private JBall ball1;
	private JBall ball2;

	public JRail() {
		setPreferredSize(new Dimension(400, 40));
		setBackground(Color.LIGHT_GRAY);
		setLayout(null);

		ball1 = new JBall();
		ball1.setV(1);
		ball1.setColor(Color.RED);
		ball1.setBounds(10, 10, 20, 20);
		add(ball1);

		ball2 = new JBall();
		ball2.setV(-2);
		ball2.setColor(Color.BLUE);
		ball2.setBounds(370, 10, 20, 20);
		add(ball2);
	}

	@Override
	protected void paintComponent(Graphics g) {
		super.paintComponent(g);

		g.setColor(Color.BLACK);
		g.drawLine(0, 0, getWidth(), 0);
		for (int x = 0; x < getWidth(); x += 10)
			g.drawLine(x, 0, x, 5);
	}

	public void start() {
		if (!running) {
			running = true;
			Thread t = new Thread(this);
			t.setDaemon(true);
			t.start();
		}
	}

	public void stop() {
		running = false;
	}

	public void reset() {
		ball1.setBounds(10, 10, 20, 20);
		ball1.setV(1);
		ball2.setBounds(370, 10, 20, 20);
		ball2.setV(-2);
	}

	@Override
	public void run() {
		while (running) {
			int x1 = ball1.getX() + ball1.getV(), y1 = ball1.getY();
			int x2 = ball2.getX() + ball2.getV(), y2 = ball2.getY();
			if (Math.abs(x1 - x2) <= JBall.SIZE) {
				int v1 = ball1.getV(), v2 = ball2.getV();
				ball1.setV(v2);
				ball2.setV(v1);
			}
			ball1.setLocation(x1, y1);
			ball2.setLocation(x2, y2);
			try {
				Thread.sleep(20);
			} catch (InterruptedException e) {
			}
		}
	}
}
