package urti;

import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.SpringLayout;

public class Main extends JFrame {
	
	private JRail rail;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main frame = new Main();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public Main() {
		setTitle("Urti");
		setBounds(100, 100, 450, 300);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		SpringLayout springLayout = new SpringLayout();
		getContentPane().setLayout(springLayout);
		
		rail = new JRail();
		springLayout.putConstraint(SpringLayout.NORTH, rail, 10, SpringLayout.NORTH, getContentPane());
		springLayout.putConstraint(SpringLayout.WEST, rail, 10, SpringLayout.WEST, getContentPane());
		springLayout.putConstraint(SpringLayout.EAST, rail, -10, SpringLayout.EAST, getContentPane());
		getContentPane().add(rail);
		
		JButton btnStart = new JButton("Start");
		springLayout.putConstraint(SpringLayout.NORTH, btnStart, 6, SpringLayout.SOUTH, rail);
		springLayout.putConstraint(SpringLayout.WEST, btnStart, 10, SpringLayout.WEST, getContentPane());
		btnStart.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				rail.start();
			}
		});
		getContentPane().add(btnStart);
		
		JButton btnStop = new JButton("Stop");
		springLayout.putConstraint(SpringLayout.NORTH, btnStop, 6, SpringLayout.SOUTH, rail);
		btnStop.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				rail.stop();
			}
		});
		springLayout.putConstraint(SpringLayout.WEST, btnStop, 6, SpringLayout.EAST, btnStart);
		getContentPane().add(btnStop);
		
		JButton btnReset = new JButton("Reset");
		springLayout.putConstraint(SpringLayout.NORTH, btnReset, 6, SpringLayout.SOUTH, rail);
		btnReset.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				rail.reset();
			}
		});
		springLayout.putConstraint(SpringLayout.WEST, btnReset, 6, SpringLayout.EAST, btnStop);
		getContentPane().add(btnReset);

	}
}
